import io
import json
from kafka import KafkaConsumer
from kafka import TopicPartition
from IPython.display import display
import datetime
import time

servers = ['localhost:9092']
def deserializer(v):
	return json.loads(v.decode('utf-8'))

topic = "weather"
verbose= "xyes"

# Determine the epoch time for date (Year,Month,Day)
start_epoch = int(datetime.datetime(2022,10,4,0,0, 0).strftime('%s'))*1000
minute_ms=60000
hour_ms=60*minute_ms
day_ms=24*hour_ms
# Set the finish time to start time plus number of ms
# NOTE: There is an issue when the time
finish_epoch=start_epoch+(17*hour_ms)


# Select and read a specific time 
#

# set up consumer and add 5 second time out 

consumer = KafkaConsumer(bootstrap_servers=servers, consumer_timeout_ms=5000,
                         value_deserializer=deserializer)

# For real installations, there will be multiple partions
# for a topic. The offset(s) that we are searching  
topic_partitions = consumer.partitions_for_topic(topic)

for part in topic_partitions:
	print("Checking partition: %d" % part)

	partition = TopicPartition('weather', part)
	consumer.assign([partition])
	start  = consumer.offsets_for_times({partition:start_epoch})
	finish  = consumer.offsets_for_times({partition:finish_epoch})
	consumer.seek(partition, start[partition].offset) 
	
	for message in consumer:
		if message.offset >= finish[partition].offset:
			break
		if message.key is not None:
			key=message.key.decode("utf-8")
		else:
			key='NO KEY'
		time=datetime.datetime.fromtimestamp(message.timestamp/1000.0)
		print("  Partition: %s Message Offset %d Zipcode %s" % (part, message.offset,key))
		print("   Time: %s (%s)" % (time, message.timestamp))

exit()

